﻿Public Class WebQQ_Interface   'Interface of the webqq proxy
    Public Shared Event On_QQ_Message_Arrive(ByVal Message As QQ_Message)
    Public Shared Event On_Polls_Arrive(ByVal Poll As String, ByRef Cancel As Boolean)
    Public Shared Event On_Command_Arrive(ByVal sender As String, ByVal group As String, ByVal cmd As String, ByVal Param As String)
    Public Shared Event On_Error(ByVal Err As String)
    Public Shared Event Finish_Sending(Result As String, target As String, Messages As Newtonsoft.Json.Linq.JToken(), IsGroup As Boolean, MessageId As Integer)
    Public Shared Event Ext_Poll_Proc(ByVal Message As Newtonsoft.Json.Linq.JToken) 'system_message, buddies_status_change, input_notify

    Public Shared Last_Err As String
    Public Shared Administrator As String

    Public Shared ReadOnly Property QQ_Number As Long
        Get
            Return Module_Main.QQ_Number
        End Get
    End Property
    Public Shared ReadOnly Property UserName As Long
        Get
            Return Module_Main.Username
        End Get
    End Property
    Public Shared ReadOnly Property AppPath As String
        Get
            Return My.Application.Info.DirectoryPath
        End Get
    End Property
    Public Shared ReadOnly Property Friend_List As QQ_Friend_List
        Get
            Return Module_Main.Friend_List
        End Get
    End Property
    Public Shared ReadOnly Property Group_List As Dictionary(Of String, String)
        Get
            Return Module_Main.Group_List
        End Get
    End Property

    Public Shared Sub Quit()
        End
    End Sub
    Public Shared Function Get_Face(ByVal Face As Integer) As Newtonsoft.Json.Linq.JArray
        Return New Newtonsoft.Json.Linq.JArray(New Newtonsoft.Json.Linq.JValue("face"), New Newtonsoft.Json.Linq.JValue(Face))
    End Function
    Public Shared Function Get_QQ_Font(Optional ByVal Name As String = "宋体", Optional ByVal Size As String = "10", Optional ByVal Color As String = "993366", Optional ByVal Style0 As Integer = 0, Optional ByVal Style1 As Integer = 0, Optional ByVal Style2 As Integer = 0) As Newtonsoft.Json.Linq.JArray
        Dim Json_Font As New Newtonsoft.Json.Linq.JArray
        Json_Font.Add(New Newtonsoft.Json.Linq.JValue("font"))
        Json_Font.Add(New Newtonsoft.Json.Linq.JObject({New Newtonsoft.Json.Linq.JProperty("name", Name),
                                                       New Newtonsoft.Json.Linq.JProperty("size", Size),
                                                       New Newtonsoft.Json.Linq.JProperty("color", Color),
                                                       New Newtonsoft.Json.Linq.JProperty("style", New Newtonsoft.Json.Linq.JArray({New Newtonsoft.Json.Linq.JValue(Style0),
                                                                                                                                   New Newtonsoft.Json.Linq.JValue(Style1),
                                                                                                                                   New Newtonsoft.Json.Linq.JValue(Style2)}))}))
        Return Json_Font
    End Function

    'Send a Message(Does not block the recieving)
    Public Shared Sub Send_Complex_Message(ByVal target As String, ByVal Messages As Newtonsoft.Json.Linq.JToken(), Optional ByVal IsGroup As Boolean = False, Optional ByVal MessageId As Integer = 3180000)
        Dim Sending_Thread As New Threading.Thread(Sub()
                                                       Dim r = Module_Main.Post_Complex_MSG(target, Messages, IsGroup, MessageId)
                                                       RaiseEvent Finish_Sending(r, target, Messages, IsGroup, MessageId)
                                                   End Sub)
        Sending_Thread.Start()
    End Sub

    'Send a Text Message(Does not block the recieving)
    Public Shared Sub Send_Text_Message(ByVal target As String, ByVal Message As String, Optional ByVal IsGroup As Boolean = False, Optional ByVal MessageId As Integer = 3180000)
        Dim Sending_Thread As New Threading.Thread(Sub()
                                                       Dim r = Post_Complex_MSG(target, {New Newtonsoft.Json.Linq.JValue(Message)}, IsGroup, MessageId)
                                                       RaiseEvent Finish_Sending(r, target, {New Newtonsoft.Json.Linq.JValue(Message)}, IsGroup, MessageId)
                                                   End Sub)
        Sending_Thread.Start()
    End Sub

    'A short cut of send message
    Public Shared Sub O(ByVal target As String, Optional ByVal IsGroup As Boolean = False, Optional ByVal Message As String = "")
        Send_Text_Message(target, Message, IsGroup)
    End Sub

    Friend Shared Sub _Ext_Poll_Proc(ByVal Message As Newtonsoft.Json.Linq.JToken)
        RaiseEvent Ext_Poll_Proc(Message)
    End Sub
    Friend Shared Sub _Error(ByVal Err As String)
        Last_Err = Err
        RaiseEvent On_Error(Err)
    End Sub
    Friend Shared Sub QQ_Message_Arrive(ByVal Message As QQ_Message)
        Dim Message_Threading As New Threading.Thread(Sub()
                                                          RaiseEvent On_QQ_Message_Arrive(Message)
                                                      End Sub)
        Message_Threading.Start()
    End Sub
    Friend Shared Function Polls_Arrive(ByVal Poll As String) As Boolean
        Dim c As Boolean
        RaiseEvent On_Polls_Arrive(Poll, c)
        Return Not c
    End Function
    Friend Shared Sub Command_Arrive(ByVal sender As String, ByVal group As String, ByVal cmd As String, ByVal Param As String)
        RaiseEvent On_Command_Arrive(sender, group, cmd, Param)
    End Sub
End Class

Public Class QQ_Message_Sender
    Public Target As String
    Public IsGroup As Boolean
    Public Sub New(_Target As String, _IsGroup As Boolean)
        Target = _Target
        IsGroup = _IsGroup
    End Sub
    Public Sub New(Message As QQ_Message)
        Target = Message.from_uin
        IsGroup = Message.From_Group
    End Sub
    Public Sub Send(Message As String)
        WebQQ_Interface.Send_Text_Message(Target, Message, IsGroup, 300000 + Rnd() * 500000)
    End Sub
End Class

Public Class QQ_Friend_Categorie
    Public Friends As IDictionary(Of String, String) = New Dictionary(Of String, String)()
    Public Name As String
    Public Index As String
    Public Sort As String
End Class

Public Class QQ_Friend_List
    Public Friends As New List(Of QQ_Friend_Categorie)
    Public _str As String
    Public Function Get_Name_From_Id(Id As String) As String
        For Each i As QQ_Friend_Categorie In Friends.ToArray
            If i.Friends.ContainsKey(Id) Then
                Return i.Friends(Id)
                Exit For
            End If
        Next
        Return ""
    End Function

    Public Function Get_All_Friends() As IDictionary(Of String, String)
        Dim r As New Dictionary(Of String, String)()
        For Each i As QQ_Friend_Categorie In Friends.ToArray
            For Each j As String In i.Friends.Keys
                r.Add(j, i.Friends(j))
            Next
        Next
        Return r
    End Function
End Class

Public Class QQ_Message
    Public From_Group As Boolean
    Public msg_id, from_uin, to_uin, msg_id2, msg_type, reply_ip, time As String
    Public group_code, send_uin, seq, info_seq As String
    Public Contents As New List(Of QQ_Message_Content)
    Public Font As New QQ_Font

    Public Function GetString() As String
        Dim r As String = ""
        For Each c As QQ_Message_Content In Contents.ToArray
            If c.Type = Content_Type.Text Then r += c.Value
        Next
        Return r
    End Function
End Class

Public Structure QQ_Font
    Public Name, Size, Color As String
    Public Style As Newtonsoft.Json.Linq.JArray
End Structure

Public Structure QQ_Message_Content
    Public Type As Content_Type
    Public Value As String
    Public Sub New(ByVal _Value As String, Optional ByVal _Type As Content_Type = Content_Type.Text)
        Value = _Value
        Type = _Type
    End Sub
End Structure

Public Enum Content_Type
    Text
    Face
    Picture
    Unknown
End Enum